

#include <iostream>
#include <iomanip>
#include <string>

#include <cstring>

#include "fonctions_code_decode.h"

using namespace std;

void AffichageHexa( const unsigned char tab[], int taille, string nom)
{
int i;
        cout << nom << "[" << dec << taille << "]: ";
        for( i=0; i<taille; i++)
                cout << hex << "0x" <<int(tab[i]) << " ";
        cout << endl;
}

double Comparaison( const unsigned char signal_ref[], const unsigned char signal[], int taille)
{
double p_erreur = 0.0;
int i;

	for( i=0; i<taille; i++)
		if( signal[i] != signal_ref[i] )
			p_erreur++;

	return (p_erreur/(1.0*taille));
}


int main(void)
{
unsigned char *message;
unsigned char *information;
unsigned char *control;
unsigned char *signal;
unsigned char *signal_bruit;
unsigned char *information_bruit;
unsigned char *control_bruit;
unsigned char *message_debruit;

int taille_message;
int taille_information_control;
int taille_signal;
int taille_message_debruit;


// Emission
//unsigned char message[20];
string str_message;
cout << " Chaine du message : ";
getline( cin, str_message);  //permet de lire une ligne contenant des espaces

//    Conversion string -> char *
  taille_message = str_message.length()+1;
  message = new unsigned char [taille_message];
  memcpy(message,  str_message.c_str(), taille_message);

  taille_information_control = GetTailleInformationControlFromMessage( taille_message );
  information = new unsigned char [ taille_information_control ];
  control     = new unsigned char [ taille_information_control ];
CodageConvolutif( message, information, control, taille_message);

  taille_signal = GetTailleSignalFromInformationControl( taille_information_control );
  signal        = new unsigned char [ taille_signal ];
MelangeInformationControl( information, control, signal, taille_information_control);


// Bruit
  signal_bruit      = new unsigned char [ taille_signal ];
BruitAdditif( signal, signal_bruit, taille_signal, 0.7, 0);


// Reception
  information_bruit = new unsigned char [ taille_information_control ];
  control_bruit     = new unsigned char [ taille_information_control ];
SepareInformationControl( signal_bruit, information_bruit, control_bruit, taille_signal);

  taille_message_debruit = GetTailleMessageFromInformationControl( taille_information_control );
  message_debruit = new unsigned char [ taille_message_debruit ];
DecodageConvolutif( information_bruit, control_bruit, message_debruit, taille_information_control);

AffichageHexa( message, taille_message,	"message          ");
cout << endl;

AffichageHexa( information, taille_information_control, "information	  ");
AffichageHexa( control, taille_information_control,	"control          ");
AffichageHexa( signal, taille_signal,		"signal          ");
cout << endl;

AffichageHexa( signal_bruit, taille_signal,		  "signal_bruit	");
AffichageHexa( information_bruit, taille_information_control, "information_bruit");
AffichageHexa( control_bruit, taille_information_control, "control_bruit    ");
cout << endl;


AffichageHexa( message_debruit, taille_message_debruit, "message_debruit  ");
cout << "message_debruit (char) "<< message_debruit << endl;
cout << endl;


cout << " > Erreur avant correction sur signal      : " << 100*Comparaison( signal, signal_bruit, taille_signal) << "%" << endl;
cout << " > Erreur avant correction sur information : " << 100*Comparaison( information, information_bruit, taille_message) << "%" << endl;
cout << " > Erreur apres correction sur information : " << 100*Comparaison( message, message_debruit, taille_message) << "%" << endl;
cout << " > Taux de correction sur information      : " << 100*Comparaison( information_bruit, message_debruit, taille_message) << "%" << endl;

delete[] information;
delete[] control;
delete[] signal;
delete[] signal_bruit;
delete[] information_bruit;
delete[] control_bruit;
delete[] message_debruit;
delete[] message;

cout << " -- pause -- " << endl;
cin.sync();
cin.get();

return 0;
}
